#include "config.h"
#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#include <stdio.h>
#include "libsub_private.h"

static struct font_handler 
{
  char *name;
  struct font **(*list)();
}
handlers[] =
{
#include "fonts.h"
};

static char **fontdirs;

void lsub_set_font_directories( char ** directories )
{
  fontdirs = directories;
}

struct font *lsub_find_font( char *name, int flags )
{
  int i, j;
  struct font *res = NULL;

  if( !fontdirs )
    return 0;

  for( i = 0; i<(int)NELEM( handlers ); i++ )
  {
    struct font **list = handlers[i].list( fontdirs );
    for( j = 0; list[j]; j++ )
      if( !strcasecmp( list[j]->name, name ) )
	if( list[j]->flags == ( flags & (FONT_BOLD|FONT_ITALIC) ) )
	  return list[ j ];
	else if(!res)
	  res = list[j];
	else
	  if( ((res->flags&FONT_BOLD) == (flags&FONT_BOLD)) +
	      ((res->flags&FONT_ITALIC) == (flags&FONT_ITALIC)) <
	      ((list[j]->flags&FONT_BOLD) == (flags&FONT_BOLD)) +
	      ((list[j]->flags&FONT_ITALIC) == (flags&FONT_ITALIC)))
	    res = list[ j ];
  }

  if( res )
    return res;

  for( i = 0; i<(int)NELEM( handlers ); i++ )
  {
    struct font **list = handlers[i].list( fontdirs );
    for( j = 0; list[j]; j++ )
      if( !strncasecmp( list[j]->name, name, strlen(name) ) )
	if( list[j]->flags == ( flags & (FONT_BOLD|FONT_ITALIC) ) )
	  return list[ j ];
	else if(!res)
	  res = list[j];
	else
	  if( ((res->flags&FONT_BOLD) && (flags&FONT_BOLD)) +
	      ((res->flags&FONT_ITALIC) && (flags&FONT_ITALIC)) <
	      ((list[j]->flags&FONT_BOLD) && (flags&FONT_BOLD)) +
	      ((list[j]->flags&FONT_ITALIC) && (flags&FONT_ITALIC)))
	    res = list[ j ];
  }

  if( res )
    return res;

  if( strcmp( name, "arial" ) )
    return lsub_find_font( "arial", flags );

  return 0;
}
			
