/* MicrDVD support. Some code (the sscanf format) from mplayer */

#include "config.h"

#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#include <stdio.h>
#include <string.h>

#include "libsub_private.h"



/*                name                identify     parse      valid exts. */
#define _FORMAT_ {"DVD",udvd_identify,udvd_parse,{"ssa",0,0,0}},

static int udvd_read_line(libsubFILE *fd,struct subtitle *current)
{
  char line[1001];
  char *lp, *part;
  int allocated_size = 0;

  do {
    if (!fd->fgets (line, 1000, fd))
      return 0;
  } while( sscanf (line, "{%ld}{%ld}%[^\r\n]",
		   &(current->start), &(current->end),line) <3);

  lp = line;

  while( (part = strsep( &lp, "|" )) )
  {
    if( current->ntext >= allocated_size )
    {
      allocated_size += 10;
      current->text = realloc( current->text,
			       allocated_size*
			       sizeof(current->text[0]) );
    }
    memset( &current->text[current->ntext],0,
	    sizeof(current->text[current->ntext]) );
    current->text[ current->ntext++ ].str  = sub_iso8859_to_unicode( part );
  }
  return 1;
}


int udvd_identify( libsubFILE *fp )
{
  char line[1000];
  int j, i;
  fp->rewind( fp );

  for( j = 0; j<100; j++ )
  {
    if (!fp->fgets (line, 1000, fp))
      return 0;
    if (sscanf (line, "{%d}{%d}%s", &i, &i, &line)==3)
      return 1;
  }
  return 0;
}

#define PFUN      udvd_parse
#define LFUN      udvd_read_line
#define CLEANUP() 
#define SORTED
#include "sub_parse_function.h"
