#define SUB_CHUNK    1024

#ifdef HAVE_KARAOKE
#define MAX_FAKE_QUEUE 256
#else
#define MAX_FAKE_QUEUE 0
#endif

#define APPEND_SUB(X) (*(res[nsubs++]=xalloc(sizeof(struct subtitle)))=X)

#ifndef SORTED
static int compare_start( const struct subtitle *a,
			  const struct subtitle *b )
{
  if( a->start < b->start )
    return -1;
  if( a->start > b->start )
    return 1;
  return 0;
}

static int _compare_start( const void *a, const void *b )
{
  return compare_start( *(struct subtitle **)a, *(struct subtitle **)b );
}
#endif

struct subtitle **PFUN( libsubFILE *f )
{
  int nsubs = 0, asubs=SUB_CHUNK;
  struct subtitle **res = xalloc( sizeof( struct subtitle * ) * SUB_CHUNK );
  struct subtitle tmp, null_tmp;
#ifdef HAVE_KARAOKE
  struct subtitle fake_event;
  int i, fakes[MAX_FAKE_QUEUE];
#endif
#ifndef HAS_STYLE
#ifndef HAVE_KARAOKE
  int i;
#endif
  struct font *fo = lsub_find_font( "Arial", FONT_BOLD );
#endif
  f->rewind( f );

#ifdef HAVE_KARAOKE
  memset( fakes, -1, MAX_FAKE_QUEUE*sizeof(int) );
  memset( &fake_event, 0, sizeof( struct subtitle ) );
#endif
  memset( &tmp, 0, sizeof( struct subtitle ) );

#ifndef HAS_STYLE
  tmp.flags = FONT_BOLD|FONT_OUTLINE|FONT_SHADOW;
  tmp.size  = 28 / 555.0;
  tmp.color = 0xffff00;
  tmp.hm = 0.0;
  tmp.vm = 0.0;
#endif

  null_tmp = tmp;

  while( LFUN( f, &tmp ) )
  {
    if( nsubs+(MAX_FAKE_QUEUE/2+1) >= asubs )
    {
      asubs+=SUB_CHUNK;
      res = realloc(res, sizeof( struct subtitle *)*asubs );
    }

#if defined(HAVE_KARAOKE) || !defined(HAS_STYLE)
    for( i = 0; i<tmp.ntext; i++ )
    {
#ifdef HAVE_KARAOKE
      int j;
#endif
#ifndef HAS_STYLE
      tmp.text[i].font = fo;
#endif
#ifdef HAVE_KARAOKE
      if( tmp.text[i].delay ) // karaoke mode. Insert fake events.
	for( j = 0; j<MAX_FAKE_QUEUE; j++ )
	  if( fakes[j] == -1 )
	  {
	    fakes[j] = tmp.start + tmp.text[i].delay+1;
	    break;
	  }
#endif
    }
#endif

#ifdef HAVE_KARAOKE
    {
      int flip = 0;
      for( i = 0; i<MAX_FAKE_QUEUE; i++ )
      {
	if( fakes[i] != -1 && fakes[i] < tmp.start )
	{
	  if( !(flip = !flip) )
	  {
	    fake_event.end = fakes[i];
	    APPEND_SUB( fake_event );
	  }
	  else
	    fake_event.start = fakes[i];
	  fakes[i] = -1;
	}
	else if( fakes[i] == tmp.start || fakes[i] == tmp.end )
	  fakes[i] = -1;
      }
      if( flip )
      {
	fake_event.end = tmp.start;
	APPEND_SUB(fake_event);
      }
    }
#endif

    APPEND_SUB(tmp);
    tmp = null_tmp;
  }
  res[nsubs] = 0;
  CLEANUP();
#ifndef SORTED
  qsort( res, nsubs, sizeof( struct subtitle *), _compare_start );
#endif
  /* Free some (very small amount, but still) memory */
  return realloc( res, sizeof( struct subtitle *)*(nsubs+1) );
}

