#include "config.h"
#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

# include <sys/time.h>
# include <stdio.h>

#include "libsub.h"
#include "libsub_private.h"
#include "test.h"


char *font_dirs[] =
{
  "/usr/X11R6/lib/X11/fonts/truetype/",
  "/c/windows/fonts",
  "/home/per/aido/fonts",
  0
};


int main( int argc, char *argv[] )
{
  FILE *f;
  int i;
  int start, stop, m, s, d;
  float fact;
  struct timeval tv;
  int now;

  struct subtitle **res;
  struct image *screen = lsub_allocate_image( W, H );
  
  lsub_set_font_directories( font_dirs );

  if( argc != 5 )
  {
    fprintf( stderr, "Syntax: test start fact stop subtitlefile\n" );
    exit(1);
  }

  sscanf( argv[1], "%d:%d.%d", &m, &s, &d );
  start = (m*60+s)*100 + d;

  sscanf( argv[2], "%d:%d.%d", &m, &s, &d );
  stop = (m*60+s)*100 + d;

  sscanf( argv[3], "%f", &fact );
  
  fprintf( stderr, "Locating and reading subtitles... ");
  res = lsub_find_subtitles_for( argv[4] );

  if( !res )
  {
    fprintf( stderr, "Failed!\n" );
    exit(1);
  }
  fprintf( stderr, "done.\n");

  gettimeofday( &tv, NULL );
  
  now = tv.tv_sec;

  while( 1 )
  {
    int t;
    gettimeofday( &tv, NULL );
    t = (int)(((tv.tv_sec - now)*100 + tv.tv_usec / 10000)*fact);
    fprintf( stderr, "  %2d:%02d:%02d.%02d  \r",
	     t/360000, (t/6000)%60, (t/100)%60, t%100 );
    if( lsub_render_subtitles( res, start+t, screen ) )
    {
      fprintf( stderr, "\n" );
      write( 1, screen->data,W*H*4 );
    }
    usleep( 10000 );
    if( t > stop-start )
      break;
  }
  lsub_free_subtitles( res );
  lsub_free_image( screen );
  exit(0);
}
