#include "config.h"

#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif
#include <stdio.h>

#include "libsub_private.h"

#ifndef HAVE_STRSEP
char *strsep( char **stringp, const char *delim )
{
  char *s = *stringp, *p = *stringp;
  for( ; *p; p++ )
    if( *p == *delim )
    {
      *p=0;
      *stringp = p+1;
      return s;
    }
  if( s != p )
  {
    *stringp  = p;
    return s;
  }
  return NULL;
}
#endif

struct font *allocate_font( )
{
  struct font *res = xalloc( sizeof( struct font ) );
  memset( res, 0, sizeof( struct font ) );
  return res;
}

struct face *allocate_face( )
{
  struct face *res = xalloc( sizeof( struct face ) );
  memset( res, 0, sizeof( struct face ) );
  return res;
}

struct image *allocate_image( int w, int h )
{
  struct image *i = xalloc( (w*h*4) +  sizeof(struct image) );
  i->data  = (void *) (((char *)i)+sizeof(struct image));
  memset( i->data, 0, w*h*4 );
  i->w = w; i->h = h;
  return i;
}

struct image *lsub_allocate_image( int w, int h )
{
  /* Wrapper for external allocations */
  return allocate_image( w, h );
}

void free_image( struct image *i )
{
  xfree( i );
}

void lsub_free_image( struct image *i )
{
  free_image( i );
}

unsigned short *sub_iso8859_to_unicode( unsigned char *c )
{
  int l = strlen( c ), i;
  short *res = xalloc( l*2+2 );
  for( i =0; i<=l; i++ )
    res[i] = c[i];
  return res;
}

void lsub_free_subtitles( struct subtitle **subs )
{
  int i, j;
  for( i = 0; subs[i]; i++ )
  {
    for( j = 0; j<subs[i]->ntext; j++ )
      if( subs[i]->text[j].str )
	free( subs[i]->text[j].str );
    free( subs[i]->text );
    free( subs[i] );
  }
  free( subs );
}
